//*************************************************
// 
// mega8
//  RC- 4.0000Mhz 
//  . startcd@narod.ru . 
//
// 				 http://startcd.narod.ru/ 
//
//*************************************************

#define	miganie //  	 ,    , .

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>
#include "font.h"
#include "reg_id10.h"

#define BIT _BV
#define F_ 		   (key==12)
#define SET_ 	   (key==8)
#define PLUS 	   (key==0)
#define MINUS	   (key==4)

//*******PORT*******
//*******PORTB*******
//k55510 PB0 PB3 PB4 PB5
//PB1 output		OC1A buzzer
#define PORT_VCC_ID	PORTB
#define DDR_VCC_ID	DDRB
#define PIN_VCC_ID 	BIT(2)
#define PORTID	   	PORTB
#define DDRID	   	DDRB
#define pin_id	   	( BIT(0)|BIT(3)|BIT(4)|BIT(5) )
//PB7				(XTAL2/TOSC2) 
//PB6				(XTAL1/TOSC1) 
//*
#define OC1A		BIT(1)
#define DDR_OC1A	DDRB

#define	PORTLCD	   PORTD
#define	DDRLCD	   DDRD
#define PINLCD	   PIND
//*/
/* m16
#define OC1A		BIT(5)
#define DDR_OC1A	DDRD

#define	PORTLCD	   PORTA
#define	DDRLCD	   DDRA
#define PINLCD	   PINA
//*/
#define	str0	   (PINLCD&BIT(0))
#define str4	   (PINLCD&BIT(1))
#define str8	   (PINLCD&BIT(2))
#define str12	   (PINLCD&BIT(3))
#define	stolb1	   (PINLCD&BIT(4))
#define	stolb2	   (PINLCD&BIT(5))
#define	stolb3	   (PINLCD&BIT(6))
#define	stolb4	   (PINLCD&BIT(7))

//#define PORT_sig_min	PORTB
//#define sig_min_00	BIT(2)

//*******PORTC*******
#define	PORT_1wire 		PORTC
#define	DDR_1wire 		DDRC
#define	PIN_1wire 		PINC
#define	pwire0 			BIT(3)	//PC3	
#define	pwire1 			BIT(4)	//PC4	

#define PORT_OUT		PORTC
#define DDR_OUT			DDRC
#define PIN_calls_osn 	BIT(0)
#define PIN_calls1 		BIT(1)
#define PIN_timer		BIT(2)

#define PORT_POWER_DETECT	PORTC
#define PIN_P_Dt			PINC
#define _power_			BIT(5)
#define pin_power_		( PIN_P_Dt & _power_ )



//-------- time_flag byte -------
#define fl_sek_1_switch			BIT(0)
#define	fl_plus					BIT(1)//  
#define	fl_sig_butt				BIT(2)//    
#define	fl_power_init_device 	BIT(3)
#define	fl_signal_out_enable	BIT(4)
#define fl_signal_cls		 	BIT(5)
#define fl_sig_otsr				BIT(6)
#define fl_calls_pin_A_on	 	BIT(7)


//----------- time_1wire_flag ---
#define fl_parasite_power		7

//----------timer[3]----------
#define fl_timer_count		 0//  BIT()!   . inc_dec_var_bit()!


//----------------------------
#define	h_sek		0//
#define	h_min		1
#define	h_hour		2
#define	h_day 		3
#define	h_num		4
#define	h_month		5
#define	h_year		6
#define	c_min		1// 
#define c_hour		2
#define c_day		3
#define c_sig		0

//----------corr_flag---------
#define fl_corr_znak_pl	0

#define ds0	0
#define ds1	1

#define true	1
#define false	0

//---time[]---
#define wire1		0
#define note		1
#define note_but	2
#define beg_str		3

#define sig_on_otsr		1	// == 1   
#define sig_on			2	// == 2   
#define sig_odnorazovoi	3	// == 3  
#define sig_foreva		4	// == 4  
#define sig_timer sig_on	// == 2    

uint8_t time_flag, regim;
uint8_t key, znakomesto, lcd_time_switch, time_in_regim, change_light, lcd_light=5, anti_drebezg[3];
unsigned char tempir_lsb[2], tempir_msb[2], out_1wire, time_1w_flag, count_com_1w, power_suplly_1w;
  signed char time[4], timer[4];
unsigned int  mask;
unsigned char clock_, isr_1sek_, hour[7]={0,0,12,0,0,0,8};//hour- year,month,num,day,hour,min,sek
unsigned char budilnik_nomer, simvol, budilnik_play_num, nedelia[2];
uint16_t time_bud_pin;
unsigned char lcd_buffer[10], bcd_num0, bcd_num1, bcd_num2, bcd_num3, bcd_num4;
unsigned char signal, time_signal, count_note, p_index;
uint8_t eeprom_err;		

uint8_t light_isr, light_disp[]={29,28,26,23,20,17,14,9,2}, light_time_mig[]={10,9,8,8,7,5,4,4,3};//{1,3,5,10,15,20,24,27};
//{28,26,24,21,18,15,10,5,2}
#define	ocr1ahi			0
#define	ocr1alow		1
#define	ocr1ahi_but		2
#define	ocr1alow_but	3

							
// callnomer-5 hour-7,8 min-10,11
uint8_t *ukaz_na_str, correct;
prog_int16_t	corr_in_lcd[51] =	{0,8,16,23,31,39,47,55,63,70,78,86,94,102,109,117,
									125,133,141,148,156,164,172,180,188,195,203,211,219,227,234,242,
									250,258,266,273,281,289,297,305,313,320,328,336,344,352,359,367,
									375,383,391};

const uint8_t 	num_in_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
const uint8_t  uprav_TCCR1B[4]={1|(1<<WGM12), 0|(1<<WGM12), 1|(1<<WGM12), 0|(1<<WGM12)};
const int8_t length_note[4]={20,10,20,75};
struct	setup {
		uint8_t day_light;
		uint8_t night_light;
		uint8_t tim_c_light;
		uint8_t tim_do_light;
		
		uint8_t budilnik[12][4];
		uint8_t budil_pin[2][3];
		uint8_t signal_bud;
		uint8_t ocr1[4];
		
		#define Count_regim	8//  
		#define num_formats	15//   ,     . view_in_indikator()
		uint8_t state_time [Count_regim];
		uint8_t state_regim[Count_regim];
		uint8_t state_skip [Count_regim];
		uint8_t vid_t;
		uint8_t corr_flag;
		uint8_t correction;
		uint16_t crc;
} setup;

struct current_state_view
{
	uint8_t regim;
	uint8_t time;
	uint8_t skip[Count_regim];
	uint8_t viewstate;
}	current_state_view;
	



